<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from lic.texi on 28 April 1999 -->

<TITLE>The Linear Inequality Calculator - Types of Variables</TITLE>
<link href="lic_8.html" rel=Next>
<link href="lic_6.html" rel=Previous>
<link href="lic_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="lic_1.html">first</A>, <A HREF="lic_6.html">previous</A>, <A HREF="lic_8.html">next</A>, <A HREF="lic_21.html">last</A> section, <A HREF="lic_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC7" HREF="lic_toc.html#TOC7">Types of Variables</A></H2>
<P>
<A NAME="IDX38"></A>
<A NAME="IDX39"></A>

</P>
<P>
There are four kinds of user defined variables that are used in this mode:

<OL>

<LI><STRONG>Integer Variables.</STRONG>

Used to store integer values.

<LI><STRONG>Inequality Variables.</STRONG>

Used to store systems of linear inequalities.

<LI><STRONG>Variables within Inequalities.</STRONG>

Used inside inequalities to describe the inequality. These represent
loop indices and symbolic constants.

<LI><STRONG>Symbolic Coefficients within Inequalities.</STRONG>

Used inside inequalities to represent symbolic coefficients. Symbolic
coefficients are an extension to the linear inequality framework (See
the SUIFMATH Library Reference Manual).
</OL>

<P>
<A NAME="IDX40"></A>
<A NAME="IDX41"></A>
<A NAME="IDX42"></A>
<A NAME="IDX43"></A>
<A NAME="IDX44"></A>
<A NAME="IDX45"></A>
<A NAME="IDX46"></A>
<A NAME="IDX47"></A>

</P>
<P>
The type of a variable is one of the above four depending on the first
use of the variable.  In the case of Integer Variables and Inequality
Variables use of a variable without first assigning to it is illegal.
Variable names cannot have multiple types or be moved across different
types.  The names of the variables can be any combination of alphabetic
characters except the reserved keywords or character strings used to
represent variables within the inequality system.

<PRE>
n = 4
A =  [ i &#60;= j ]
B = [ L*Pr &#60;= ir &#60; L*Pr + L]
</PRE>

<P>
<A NAME="IDX48"></A>
where <SAMP>`n'</SAMP> is an integer variable, <SAMP>`A'</SAMP> and <SAMP>`B'</SAMP> are
Inequality Variables, <SAMP>`i'</SAMP>, <SAMP>`j'</SAMP>, <SAMP>`Pr'</SAMP> and <SAMP>`ir'</SAMP> are
Variables within Inequalities and finally <SAMP>`L'</SAMP> is a Symbolic
Coefficient within the Inequality.  The determination of whether a
variable is a symbolic coefficient or a variable within an inequality is
made by looking at the expression.  If two variables are multiplied, the
variable on the left is considered a symbolic coefficient, while the
variable on the right is a variable within an inequality.  There is no
other way to distinguish between the two types of variables.  However,
once a variable has been determined to be one or the other, it will
remain that type throughout the execution of <CODE>LIC</CODE>.

</P>

<P><HR><P>
<p>Go to the <A HREF="lic_1.html">first</A>, <A HREF="lic_6.html">previous</A>, <A HREF="lic_8.html">next</A>, <A HREF="lic_21.html">last</A> section, <A HREF="lic_toc.html">table of contents</A>.
</BODY>
</HTML>
